/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; tab-width: 4 -*-
 * ex: set softtabstop=4 tabstop=8 expandtab shiftwidth=4: *
 * Editor Settings: expandtabs and use 4 spaces for indentation */

/*
 * Copyright Likewise Software
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.  You should have received a copy of the GNU General
 * Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * LIKEWISE SOFTWARE MAKES THIS SOFTWARE AVAILABLE UNDER OTHER LICENSING
 * TERMS AS WELL.  IF YOU HAVE ENTERED INTO A SEPARATE LICENSE AGREEMENT
 * WITH LIKEWISE SOFTWARE, THEN YOU MAY ELECT TO USE THE SOFTWARE UNDER THE
 * TERMS OF THAT SOFTWARE LICENSE AGREEMENT INSTEAD OF THE TERMS OF THE GNU
 * GENERAL PUBLIC LICENSE, NOTWITHSTANDING THE ABOVE NOTICE.  IF YOU
 * HAVE QUESTIONS, OR WISH TO REQUEST A COPY OF THE ALTERNATE LICENSING
 * TERMS OFFERED BY LIKEWISE SOFTWARE, PLEASE CONTACT LIKEWISE SOFTWARE AT
 * license@likewisesoftware.com
 */

/*
 * Copyright (C) Likewise Software. All rights reserved.
 *
 * Module Name:
 *
 *        samdbcontext.c
 *
 * Abstract:
 *
 *
 *      Likewise SAM Database Provider
 *
 *      SamDb context initialisation routines
 *
 * Authors: Rafal Szczesniak (rafal@likewise.com)
 *
 */

#ifndef __SAMDB_CONTEXT_H__
#define __SAMDB_CONTEXT_H__


DWORD
SamDbAcquireContext(
    PSAMDB_CONTEXT* pDbContext
    );


DWORD
SamDbAcquireContext_inlock(
    PSAMDB_CONTEXT* pDbContext
    );


VOID
SamDbReleaseContext(
    PSAMDB_CONTEXT DbContext
    );


VOID
SamDbReleaseContext_inlock(
    PSAMDB_CONTEXT DbContext
    );


VOID
SamDbFreeContextList(
    VOID
    );


DWORD
SamDbGetLocalDomainSid(
    PSID* pSid
    );


DWORD
SamDbGetLocalDomainSidInternal(
    PSAMDB_CONTEXT DbContext,
    PSID* pSid
    );


#endif /* __SAMDB_CONTEXT_H__ */
