/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; tab-width: 4 -*-
 * ex: set softtabstop=4 tabstop=8 expandtab shiftwidth=4: *
 * Editor Settings: expandtabs and use 4 spaces for indentation */

/*
 * Copyright Likewise Software
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.  You should have received a copy of the GNU General
 * Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * LIKEWISE SOFTWARE MAKES THIS SOFTWARE AVAILABLE UNDER OTHER LICENSING
 * TERMS AS WELL.  IF YOU HAVE ENTERED INTO A SEPARATE LICENSE AGREEMENT
 * WITH LIKEWISE SOFTWARE, THEN YOU MAY ELECT TO USE THE SOFTWARE UNDER THE
 * TERMS OF THAT SOFTWARE LICENSE AGREEMENT INSTEAD OF THE TERMS OF THE GNU
 * GENERAL PUBLIC LICENSE, NOTWITHSTANDING THE ABOVE NOTICE.  IF YOU
 * HAVE QUESTIONS, OR WISH TO REQUEST A COPY OF THE ALTERNATE LICENSING
 * TERMS OFFERED BY LIKEWISE SOFTWARE, PLEASE CONTACT LIKEWISE SOFTWARE AT
 * license@likewisesoftware.com
 */

/*
 * Copyright (C) Likewise Software. All rights reserved.
 *
 * Module Name:
 *
 *        samdbstructs.h
 *
 * Abstract:
 *
 *
 *      Likewise SAM Database Provider
 *
 *      SAM database structures
 *
 * Authors: Krishna Ganugapati (krishnag@likewise.com)
 *          Sriram Nambakam (snambakam@likewise.com)
 *          Rafal Szczesniak (rafal@likewise.com)
 *
 */

#ifndef __SAMDBSTRUCTS_H__
#define __SAMDBSTRUCTS_H__


typedef struct _SAMDB_CONTEXT
{
    sqlite3* DbHandle;

    struct _SAMDB_CONTEXT* Next;

} SAMDB_CONTEXT, *PSAMDB_CONTEXT;


typedef struct _SAMDB_GROUP_MEMBERSHIP
{
    PSID LocalGroupSid;
    DWORD MemberRid;

} SAMDB_GROUP_MEMBERSHIP, *PSAMDB_GROUP_MEMBERSHIP;


typedef struct _SAMDB_GLOBALS
{
    LONG ReferenceCount;

    pthread_mutex_t Mutex;
    pthread_mutex_t* pMutex;

    pthread_rwlock_t  RwLock;
    pthread_rwlock_t* pRwLock;

    PSAMDB_CONTEXT DbContextList;
    DWORD NumDbContexts;
    DWORD MaxNumDbContexts;

    PSID LocalDomainSid;

    PSAMDB_GROUP_MEMBERSHIP BuiltinMemberships;
    DWORD BuiltinMembershipsCount;

    LW_LIST_ENTRY NotifyCallbacks;

} SAMDB_GLOBALS, *PSAMDB_GLOBALS;


struct _SAMDB_CALLBACK_REGISTRATION
{
    LW_LIST_LINKS Record;
    PSID ObjectSid;
    BOOLEAN IsPrefix;
    PVOID Context;
    SAMDB_RELOAD_CALLBACK CallbackFn;
};



#endif /* __SAMDBSTRUCTS_H__ */
