/* Editor Settings: expandtabs and use 4 spaces for indentation
 * ex: set softtabstop=4 tabstop=8 expandtab shiftwidth=4: *
 */

/*
 *
 *   NT status and Win32 error code mapping table
 *
 *   Some of these definitions were written from scratch.
 *
 *   NT status codes are unsigned 32-bit hex values
 *
 *   Win32 error codes are unsigned 32-bit decimal values
 */

/* Equivalence table*/
#ifdef __ERROR_XMACRO__
#define S STATUS_CODE

// List of lw extended errors
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_CACHE_PATH, ERRSRV, ERRerror, -1, "An invalid cache path was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_CONFIG_PATH, ERRSRV, ERRerror, -1, "The path to the configuration file is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_PREFIX_PATH, ERRSRV, ERRerror, -1, "The product installation folder could not be determined" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INSUFFICIENT_BUFFER, ERRSRV, ERRerror, -1, "The provided buffer is insufficient" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_OUT_OF_MEMORY, ERRSRV, ERRerror, -1, "Out of memory" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_MESSAGE, ERRSRV, ERRerror, -1, "The Inter Process message is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNEXPECTED_MESSAGE, ERRSRV, ERRerror, -1, "An unexpected Inter Process message was received" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_USER, ERRSRV, ERRerror, -1, "No such user" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DATA_ERROR, ERRSRV, ERRerror, -1, "The cached data is incorrect" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NOT_IMPLEMENTED, ERRSRV, ERRerror, -1, "The requested feature has not been implemented yet" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_CONTEXT_ITEM, ERRSRV, ERRerror, -1, "The requested item was not found in context" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_GROUP, ERRSRV, ERRerror, -1, "No such group" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_REGEX_COMPILE_FAILED, ERRSRV, ERRerror, -1, "Failed to compile regular expression" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NSS_EDIT_FAILED, ERRSRV, ERRerror, -1, "Failed to edit nsswitch configuration" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_HANDLER, ERRSRV, ERRerror, -1, "No authentication Provider was found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INTERNAL, ERRSRV, ERRerror, -1, "Internal error" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NOT_HANDLED, ERRSRV, ERRerror, -1, "The authentication request could not be handled" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_DNS_RESPONSE, ERRSRV, ERRerror, -1, "Response from DNS is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DNS_RESOLUTION_FAILED, ERRSRV, ERRerror, -1, "Failed to resolve query using DNS" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_FAILED_TIME_CONVERSION, ERRSRV, ERRerror, -1, "Failed to convert the time" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_SID, ERRSRV, ERRerror, -1, "The security identifier (SID) is invalid" )
// Triggered by passing a bad password for a valid username to domainjoin
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_PASSWORD_MISMATCH, ERRSRV, ERRerror, -1, "The password is incorrect for the given username" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNEXPECTED_DB_RESULT, ERRSRV, ERRerror, -1, "Unexpected cached data found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_PASSWORD_EXPIRED, ERRSRV, ERRerror, -1, "Password expired" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ACCOUNT_EXPIRED, ERRSRV, ERRerror, -1, "Account expired" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_USER_EXISTS, ERRSRV, ERRerror, -1, "A user by this name already exists" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_GROUP_EXISTS, ERRSRV, ERRerror, -1, "A group by this name already exists" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_GROUP_INFO_LEVEL, ERRSRV, ERRerror, -1, "An invalid group info level was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_USER_INFO_LEVEL, ERRSRV, ERRerror, -1, "An invalid user info level was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNSUPPORTED_USER_LEVEL, ERRSRV, ERRerror, -1, "This interface does not support the user info level specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNSUPPORTED_GROUP_LEVEL, ERRSRV, ERRerror, -1, "This interface does not support the group info level specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_LOGIN_ID, ERRSRV, ERRerror, -1, "The login id is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_HOMEDIR, ERRSRV, ERRerror, -1, "The home directory is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_GROUP_NAME, ERRSRV, ERRerror, -1, "The group name is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_MORE_GROUPS, ERRSRV, ERRerror, -1, "No more groups" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_MORE_USERS, ERRSRV, ERRerror, -1, "No more users" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_FAILED_ADD_USER, ERRSRV, ERRerror, -1, "Failed to add user" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_FAILED_ADD_GROUP, ERRSRV, ERRerror, -1, "Failed to add group" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_LSA_CONNECTION, ERRSRV, ERRerror, -1, "The connection to the authentication service is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_AUTH_PROVIDER, ERRSRV, ERRerror, -1, "The authentication provider is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_PARAMETER, ERRSRV, ERRerror, -1, "Invalid parameter" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NO_PARENT_DN, ERRSRV, ERRerror, -1, "No distinguished name found in LDAP for parent of this object" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_ERROR, ERRSRV, ERRerror, -1, "An Error was encountered when negotiating with LDAP" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_DOMAIN, ERRSRV, ERRerror, -1, "Unknown Active Directory domain" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_FAILED_GETDN, ERRSRV, ERRerror, -1, "Failed to find distinguished name using LDAP" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DUPLICATE_DOMAINNAME, ERRSRV, ERRerror, -1, "A duplicate Active Directory domain name was found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_KRB5_CALL_FAILED, ERRSRV, ERRerror, -1, "The call to Kerberos 5 failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_GSS_CALL_FAILED, ERRSRV, ERRerror, -1, "The GSS call failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_FAILED_FIND_DC, ERRSRV, ERRerror, -1, "Failed to find the domain controller" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_CELL, ERRSRV, ERRerror, -1, "Failed to find the Cell in Active Directory" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_GROUP_IN_USE, ERRSRV, ERRerror, -1, "The specified group is currently being used" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_FAILED_CREATE_HOMEDIR, ERRSRV, ERRerror, -1, "Failed to create home directory for user" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_PASSWORD_TOO_WEAK, ERRSRV, ERRerror, -1, "The specified password is not strong enough" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_SID_REVISION, ERRSRV, ERRerror, -1, "The security descriptor (SID) has an invalid revision" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ACCOUNT_LOCKED, ERRSRV, ERRerror, -1, "The user account is locked" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ACCOUNT_DISABLED, ERRSRV, ERRerror, -1, "The user account is disabled" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_USER_CANNOT_CHANGE_PASSWD, ERRSRV, ERRerror, -1, "The user is not allowed to change his/her password" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LOAD_LIBRARY_FAILED, ERRSRV, ERRerror, -1, "Failed to dynamically load a library" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LOOKUP_SYMBOL_FAILED, ERRSRV, ERRerror, -1, "Failed to lookup a symbol in a dynamic library" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_EVENTLOG, ERRSRV, ERRerror, -1, "The Eventlog interface is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_CONFIG, ERRSRV, ERRerror, -1, "The specified configuration (file) is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNEXPECTED_TOKEN, ERRSRV, ERRerror, -1, "An unexpected token was encountered in the configuration" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NO_RECORDS_FOUND, ERRSRV, ERRerror, -1, "No records were found in the cache" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DUPLICATE_USERNAME, ERRSRV, ERRerror, -1, "A duplicate user record was found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DUPLICATE_GROUPNAME, ERRSRV, ERRerror, -1, "A duplicate group record was found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DUPLICATE_CELLNAME, ERRSRV, ERRerror, -1, "A duplicate cell was found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_STRING_CONV_FAILED, ERRSRV, ERRerror, -1, "Failed to convert string format (wide/ansi)" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_PASSWORD, ERRSRV, ERRerror, -1, "The password is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_QUERY_CREATION_FAILED, ERRSRV, ERRerror, -1, "Failed to create query to examine cache" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_OBJECT, ERRSRV, ERRerror, -1, "No such user, group or domain object" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DUPLICATE_USER_OR_GROUP, ERRSRV, ERRerror, -1, "A duplicate user or group was found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_KRB5_CACHE_TYPE, ERRSRV, ERRerror, -1, "An invalid kerberos 5 cache type was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_FAILED_TO_SET_TIME, ERRSRV, ERRerror, -1, "The system time could not be set" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_NETBIOS_NAME, ERRSRV, ERRerror, -1, "Failed to find NetBIOS name for the domain" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_NETLOGON_RESPONSE, ERRSRV, ERRerror, -1, "The Netlogon response buffer is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_OBJECTGUID, ERRSRV, ERRerror, -1, "The specified Globally Unique Identifier (GUID) is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_DOMAIN, ERRSRV, ERRerror, -1, "The domain name is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_DEFAULT_REALM, ERRSRV, ERRerror, -1, "The kerberos default realm is not set" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NOT_SUPPORTED, ERRSRV, ERRerror, -1, "The request is not supported" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LOGON_FAILURE, ERRSRV, ERRerror, -1, "The logon request failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SITE_INFORMATION, ERRSRV, ERRerror, -1, "No site information was found for the active directory domain" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_LDAP_STRING, ERRSRV, ERRerror, -1, "The LDAP string value is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_LDAP_ATTR_VALUE, ERRSRV, ERRerror, -1, "The LDAP attribute value is NULL or invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NULL_BUFFER, ERRSRV, ERRerror, -1, "An invalid buffer was provided" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_CLOCK_SKEW, ERRSRV, ERRerror, -1, "Clock skew detected with active directory server" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_KRB5_NO_KEYS_FOUND, ERRSRV, ERRerror, -1, "No kerberos keys found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_SERVICE_NOT_AVAILABLE, ERRSRV, ERRerror, -1, "The authentication service is not available" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_SERVICE_RESPONSE, ERRSRV, ERRerror, -1, "Invalid response from the authentication service" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NSS_ERROR, ERRSRV, ERRerror, -1, "Name Service Switch Error" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_AUTH_ERROR, ERRSRV, ERRerror, -1, "Authentication Error" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_LDAP_DN, ERRSRV, ERRerror, -1, "Invalid Ldap distinguished name (DN)" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NOT_MAPPED, ERRSRV, ERRerror, -1, "Account Name or SID not mapped" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_NETLOGON_FAILED, ERRSRV, ERRerror, -1, "Calling librpc/NetLogon API failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ENUM_DOMAIN_TRUSTS_FAILED, ERRSRV, ERRerror, -1, "Enumerating domain trusts failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_LSABINDING_FAILED, ERRSRV, ERRerror, -1, "Calling librpc/Lsa Binding failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_OPENPOLICY_FAILED, ERRSRV, ERRerror, -1, "Calling librpc/Lsa Open Policy failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_LSA_LOOKUPNAME2_FAILED, ERRSRV, ERRerror, -1, "Calling librpc/Lsa LookupName2 failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_SET_SESS_CREDS_FAILED, ERRSRV, ERRerror, -1, "RPC Set Session Creds failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_REL_SESS_CREDS_FAILED, ERRSRV, ERRerror, -1, "RPC Release Session Creds failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_CLOSEPOLICY_FAILED, ERRSRV, ERRerror, -1, "Calling librpc/Lsa Close Handle/policy failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_LSA_LOOKUPNAME2_NOT_FOUND, ERRSRV, ERRerror, -1, "No user/group was found using RPC lookup name to objectSid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_LSA_LOOKUPNAME2_FOUND_DUPLICATES, ERRSRV, ERRerror, -1, "Abnormal duplicates were found using RPC lookup name to objectSid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_TRUSTED_DOMAIN_FOUND, ERRSRV, ERRerror, -1, "No such trusted domain found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INCOMPATIBLE_MODES_BETWEEN_TRUSTEDDOMAINS, ERRSRV, ERRerror, -1, "Trusted domain is executing in an incompatiable modes" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DCE_CALL_FAILED, ERRSRV, ERRerror, -1, "A call to DCE/RPC failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_FAILED_TO_LOOKUP_DC, ERRSRV, ERRerror, -1, "Failed to lookup the domain controller for given domain" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_NSS_ARTEFACT_INFO_LEVEL, ERRSRV, ERRerror, -1, "An invalid nss artefact info level was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNSUPPORTED_NSS_ARTEFACT_LEVEL, ERRSRV, ERRerror, -1, "The NSS artefact info level specified is not supported" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_USER_NAME, ERRSRV, ERRerror, -1, "An invalid user name was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_LOG_LEVEL, ERRSRV, ERRerror, -1, "An invalid log level was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_METRIC_TYPE, ERRSRV, ERRerror, -1, "An invalid metric type was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_METRIC_PACK, ERRSRV, ERRerror, -1, "An invalid metric pack was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_METRIC_INFO_LEVEL, ERRSRV, ERRerror, -1, "An invalid info level was specified when querying metrics" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_FAILED_STARTUP_PREREQUISITE_CHECK, ERRSRV, ERRerror, -1, "The system hostname configuration is incorrect" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_MAC_FLUSH_DS_CACHE_FAILED, ERRSRV, ERRerror, -1, "Could not find DirectoryService cache utility to call -flushcache with" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LSA_SERVER_UNREACHABLE, ERRSRV, ERRerror, -1, "The LSASS server is not responding." )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_NSS_ARTEFACT_TYPE, ERRSRV, ERRerror, -1, "An invalid NSS Artefact type was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_AGENT_VERSION, ERRSRV, ERRerror, -1, "The LSASS Server version is invalid" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DOMAIN_IS_OFFLINE, ERRSRV, ERRerror, -1, "The domain is offline" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_HOMEDIR_TEMPLATE, ERRSRV, ERRerror, -1, "An invalid home directory template was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_PARSE_SID_STRING, ERRSRV, ERRerror, -1, "Failed to use NetAPI to parse SID string" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_LSA_LOOKUPSIDS_FAILED, ERRSRV, ERRerror, -1, "Failed to use NetAPI to lookup names for SIDs" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_LSA_LOOKUPSIDS_NOT_FOUND, ERRSRV, ERRerror, -1, "Failed to find any names for SIDs using NetAPI" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_LSA_LOOKUPSIDS_FOUND_DUPLICATES, ERRSRV, ERRerror, -1, "Found duplicates using RPC Call to lookup SIDs" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_PASSWORD_RESTRICTION, ERRSRV, ERRerror, -1, "Password does not meet requirements" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_OBJECT_NOT_ENABLED, ERRSRV, ERRerror, -1, "The user/group is not enabled in the cell" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_MORE_NSS_ARTEFACTS, ERRSRV, ERRerror, -1, "No more NSS Artefacts" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_NSS_MAP_NAME, ERRSRV, ERRerror, -1, "An invalid name was specified for the NIS map" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_NSS_KEY_NAME, ERRSRV, ERRerror, -1, "An invalid name was specified for the NIS key" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_NSS_KEY, ERRSRV, ERRerror, -1, "No such NIS Key is defined" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_NSS_MAP, ERRSRV, ERRerror, -1, "No such NIS Map is defined" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_ERROR, ERRSRV, ERRerror, -1, "An Error was encountered when negotiating with RPC" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_SERVER_UNAVAILABLE, ERRSRV, ERRerror, -1, "The LDAP server is unavailable" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_CREATE_KEY_FAILED, ERRSRV, ERRerror, -1, "Could not create random key" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_CANNOT_DETECT_USER_PROCESSES, ERRSRV, ERRerror, -1, "Cannot detect user processes" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_TRACE_NOT_INITIALIZED, ERRSRV, ERRerror, -1, "Tracing has not been initialized" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_TRACE_FLAG, ERRSRV, ERRerror, -1, "The trace flag is not defined" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DCERPC_ERROR, ERRSRV, ERRerror, -1, "DCE-RPC Error" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_RPC_SERVER, ERRSRV, ERRerror, -1, "Invalid RPC Server" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_SERVER_REGISTRATION_ERROR, ERRSRV, ERRerror, -1, "RPC Server Registration error" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_RPC_SERVER_RUNTIME_ERROR, ERRSRV, ERRerror, -1, "RPC Server runtime error" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DOMAIN_IN_USE, ERRSRV, ERRerror, -1, "The domain is in use" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_SAM_DATABASE_ERROR, ERRSRV, ERRerror, -1, "SAM database error" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_SAM_INIT_ERROR, ERRSRV, ERRerror, -1, "Error when initializing SAM subsystem" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_OBJECT_IN_USE, ERRSRV, ERRerror, -1, "The object is in use" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_ATTRIBUTE, ERRSRV, ERRerror, -1, "No such attribute was found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_GET_DC_NAME_FAILED, ERRSRV, ERRerror, -1, "Get domain controller name failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_ATTRIBUTE_VALUE, ERRSRV, ERRerror, -1, "An invalid attribute value was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_ATTRIBUTE_VALUE, ERRSRV, ERRerror, -1, "No attribute value was found" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_MEMBER_IN_LOCAL_GROUP, ERRSRV, ERRerror, -1, "Member is in local group" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_MEMBER_NOT_IN_LOCAL_GROUP, ERRSRV, ERRerror, -1, "No such member in local group" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_GROUP, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_WARNING_CONTINUE_NEEDED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ACCESS_DENIED, ERRSRV, ERRerror, -1, "Incorrect access attempt" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_PROCESS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INTERRUPTED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_GENERIC_IO, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_HANDLE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENXIO, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_E2BIG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOEXEC, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ECHILD, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EAGAIN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EFAULT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOTBLK, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EBUSY, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EEXIST, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EXDEV, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENODEV, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOTDIR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EISDIR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENFILE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EMFILE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOTTY, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ETXTBSY, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EFBIG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOSPC, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ESPIPE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EROFS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EMLINK, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EPIPE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EDOM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ERANGE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNKNOWN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENAMETOOLONG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOLCK, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOTEMPTY, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ELOOP, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOMSG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EIDRM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ECHRNG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EL2NSYNC, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EL3HLT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EL3RST, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ELNRNG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EUNATCH, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOCSI, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EL2HLT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EBADE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EBADR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EXFULL, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOANO, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EBADRQC, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EBADSLT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EDEADLOCK, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EBFONT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOSTR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENODATA, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ETIME, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOSR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENONET, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOPKG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EREMOTE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOLINK, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EADV, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ESRMNT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ECOMM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EPROTO, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EMULTIHOP, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EDOTDOT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EBADMSG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EOVERFLOW, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOTUNIQ, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EBADFD, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EREMCHG, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ELIBACC, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ELIBBAD, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ELIBSCN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ELIBMAX, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ELIBEXEC, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EILSEQ, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ERESTART, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ESTRPIPE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EUSERS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOTSOCK, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EDESTADDRREQ, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EMSGSIZE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EPROTOTYPE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOPROTOOPT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EPROTONOSUPPORT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ESOCKTNOSUPPORT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EOPNOTSUPP, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EPFNOSUPPORT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EAFNOSUPPORT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EADDRINUSE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EADDRNOTAVAIL, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENETDOWN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENETUNREACH, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENETRESET, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ECONNABORTED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ECONNRESET, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOBUFS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EISCONN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOTCONN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ESHUTDOWN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ETOOMANYREFS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ETIMEDOUT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ECONNREFUSED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EHOSTDOWN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EHOSTUNREACH, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EALREADY, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EINPROGRESS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ESTALE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EUCLEAN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOTNAM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENAVAIL, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EISNAM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EREMOTEIO, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EDQUOT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ENOMEDIUM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_EMEDIUMTYPE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_ERRNO_ECANCELED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_SERVER_DOWN, ERRSRV, ERRerror, -1, "The DC closed an LDAP connection in the middle of a query" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_LOCAL_ERROR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_ENCODING_ERROR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_DECODING_ERROR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_TIMEOUT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_AUTH_UNKNOWN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_FILTER_ERROR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_USER_CANCELLED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_PARAM_ERROR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NO_MEMORY, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CONNECT_ERROR, ERRSRV, ERRerror, -1, "The DC sent a notice of disconnect to a LDAP connection during the query." )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NOT_SUPPORTED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CONTROL_NOT_FOUND, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NO_RESULTS_RETURNED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_MORE_RESULTS_TO_RETURN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CLIENT_LOOP, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_REFERRAL_LIMIT_EXCEEDED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_OPERATIONS_ERROR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_PROTOCOL_ERROR, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_TIMELIMIT_EXCEEDED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_SIZELIMIT_EXCEEDED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_COMPARE_FALSE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_COMPARE_TRUE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_STRONG_AUTH_NOT_SUPPORTED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_STRONG_AUTH_REQUIRED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_PARTIAL_RESULTS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NO_SUCH_ATTRIBUTE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_UNDEFINED_TYPE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_INAPPROPRIATE_MATCHING, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CONSTRAINT_VIOLATION, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_TYPE_OR_VALUE_EXISTS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NO_SUCH_OBJECT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_ALIAS_PROBLEM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_INVALID_DN_SYNTAX, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_IS_LEAF, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_ALIAS_DEREF_PROBLEM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_REFERRAL, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_ADMINLIMIT_EXCEEDED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_UNAVAILABLE_CRITICAL_EXTENSION, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CONFIDENTIALITY_REQUIRED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_SASL_BIND_IN_PROGRESS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_X_PROXY_AUTHZ_FAILURE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_INAPPROPRIATE_AUTH, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_INVALID_CREDENTIALS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_INSUFFICIENT_ACCESS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_BUSY, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_UNAVAILABLE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_UNWILLING_TO_PERFORM, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_LOOP_DETECT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NAMING_VIOLATION, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_OBJECT_CLASS_VIOLATION, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NOT_ALLOWED_ON_NONLEAF, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NOT_ALLOWED_ON_RDN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_ALREADY_EXISTS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NO_OBJECT_CLASS_MODS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_RESULTS_TOO_LARGE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_AFFECTS_MULTIPLE_DSAS, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CUP_RESOURCES_EXHAUSTED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CUP_SECURITY_VIOLATION, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CUP_INVALID_DATA, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CUP_UNSUPPORTED_SCHEME, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CUP_RELOAD_REQUIRED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CANCELLED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_NO_SUCH_OPERATION, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_TOO_LATE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_CANNOT_CANCEL, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_ASSERTION_FAILED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_LDAP_INVALID_SYNTAX, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_BAD_MECH, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_BAD_NAMETYPE, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_BAD_NAME, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_CONTEXT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_CREDENTIAL, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_CONTEXT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_CRED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_TOKEN, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNSUPPORTED_SUBPROTO, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UNSUPPORTED_CRYPTO_OP, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_TEST_FAILED, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_CSV_BAD_FORMAT, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_CSV_NO_SUCH_FIELD, ERRSRV, ERRerror, -1, "" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_SERVICE_TRANSITION, ERRSRV, ERRerror, -1, "The operation is invalid from the service's present state" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_SERVICE_DEPENDENCY_UNMET, ERRSRV, ERRerror, -1, "The service cannot be started because another service it depends on is not running" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_SERVICE_UNRESPONSIVE, ERRSRV, ERRerror, -1, "The service is not responding to requests" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_NO_SUCH_SERVICE, ERRSRV, ERRerror, -1, "No service with the specified name exists" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_DEPENDENT_SERVICE_STILL_RUNNING, ERRSRV, ERRerror, -1, "The service cannot be stopped because another service that depends on it is still running" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_INVALID_OU, ERRSRV, ERRerror, -1, "An invalid Organizational Unit was specified" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UID_TOO_LOW, ERRSRV, ERRerror, -1, "The specified user ID too low" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_UID_TOO_HIGH, ERRSRV, ERRerror, -1, "The specified user ID too high" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_GID_TOO_LOW, ERRSRV, ERRerror, -1, "The specified group ID too low" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_GID_TOO_HIGH, ERRSRV, ERRerror, -1, "The specified group ID too high" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_AUTOENROLL_FAILED, ERRSRV, ERRerror, -1, "Certificate auto-enrollment failed with a general SOAP fault" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_AUTOENROLL_HTTP_REQUEST_FAILED, ERRSRV, ERRerror, -1, "Certificate auto-enrollment HTTP request failed" )
S ( LW_STATUS_MESSAGE_NOT_FOUND, LW_ERROR_AUTOENROLL_SUBJECT_NAME_REQUIRED, ERRSRV, ERRerror, -1, "A subject name must be provided for the specified certificate template" )

#include "lwerror-table-krb5.h"

#undef S
#endif


/*
local variables:
mode: c
c-basic-offset: 4
indent-tabs-mode: nil
tab-width: 4
end:
*/
