/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; tab-width: 4 -*-
 * ex: set softtabstop=4 tabstop=8 expandtab shiftwidth=4: *
 * Editor Settings: expandtabs and use 4 spaces for indentation */

/*
 * Copyright Likewise Software
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.  You should have received a copy of the GNU General
 * Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * LIKEWISE SOFTWARE MAKES THIS SOFTWARE AVAILABLE UNDER OTHER LICENSING
 * TERMS AS WELL.  IF YOU HAVE ENTERED INTO A SEPARATE LICENSE AGREEMENT
 * WITH LIKEWISE SOFTWARE, THEN YOU MAY ELECT TO USE THE SOFTWARE UNDER THE
 * TERMS OF THAT SOFTWARE LICENSE AGREEMENT INSTEAD OF THE TERMS OF THE GNU
 * GENERAL PUBLIC LICENSE, NOTWITHSTANDING THE ABOVE NOTICE.  IF YOU
 * HAVE QUESTIONS, OR WISH TO REQUEST A COPY OF THE ALTERNATE LICENSING
 * TERMS OFFERED BY LIKEWISE SOFTWARE, PLEASE CONTACT LIKEWISE SOFTWARE AT
 * license@likewisesoftware.com
 */

/*
 * Copyright (C) Likewise Software. All rights reserved.
 *
 * Module Name:
 *
 *        defs.h
 *
 * Abstract:
 *
 *        Likewise IO (LWIO) - SRV
 *
 *        Elements
 *
 *        Definitions
 *
 * Authors: Sriram Nambakam (snambakam@likewise.com)
 *
 */

#define LWIO_DEFAULT_GLOBAL_CREDIT_LIMIT   250000
#define LWIO_DEFAULT_GLOBAL_CREDIT_RESERVE 1024
#define LWIO_DEFAULT_CLIENT_CREDIT_LIMIT   8192
#define LWIO_DEFAULT_CLIENT_CREDIT_FLOOR   4
#define LWIO_DEFAULT_CLIENT_CREDIT_START   512
#define LWIO_SRV_CREDIT_INCREMENT          32

#define LWIO_MAX_GLOBAL_CREDIT_LIMIT       4194304
#define LWIO_MAX_CLIENT_CREDIT_LIMIT       8192
#define LWIO_MAX_CLIENT_CREDIT_FLOOR       512

#define SRV_ELEMENTS_CONFIG_TABLE_INITIALIZER                   \
{                                                               \
    {                                                           \
        .pszName        = "GlobalCreditLimit",                  \
        .bUsePolicy     = FALSE,                                \
        .Type           = LwIoTypeDword,                        \
        .dwMin          = LWIO_DEFAULT_CLIENT_CREDIT_FLOOR,     \
        .dwMax          = LWIO_MAX_GLOBAL_CREDIT_LIMIT,         \
        .pValue         = &pConfig->ulGlobalCreditLimit         \
    },                                                          \
    {                                                           \
        .pszName        = "GlobalCreditReserve",                \
        .bUsePolicy     = FALSE,                                \
        .Type           = LwIoTypeDword,                        \
        .dwMin          = 0,                                    \
        .dwMax          = LWIO_MAX_GLOBAL_CREDIT_LIMIT,         \
        .pValue         = &pConfig->ulGlobalCreditReserve       \
    },                                                          \
    {                                                           \
        .pszName        = "ClientCreditLimit",                  \
        .bUsePolicy     = FALSE,                                \
        .Type           = LwIoTypeDword,                        \
        .dwMin          = LWIO_DEFAULT_CLIENT_CREDIT_FLOOR,     \
        .dwMax          = LWIO_MAX_CLIENT_CREDIT_LIMIT,         \
        .pValue         = &pConfig->ulClientCreditLimit         \
    },                                                          \
    {                                                           \
        .pszName        = "ClientCreditMinimum",                \
        .bUsePolicy     = FALSE,                                \
        .Type           = LwIoTypeDword,                        \
        .dwMin          = LWIO_DEFAULT_CLIENT_CREDIT_FLOOR,     \
        .dwMax          = LWIO_MAX_CLIENT_CREDIT_FLOOR,         \
        .pValue         = &pConfig->ulClientCreditFloor         \
    },                                                          \
    {                                                           \
        .pszName        = "ClientCreditStart",                  \
        .bUsePolicy     = FALSE,                                \
        .Type           = LwIoTypeDword,                        \
        .dwMin          = LWIO_DEFAULT_CLIENT_CREDIT_FLOOR,     \
        .dwMax          = LWIO_MAX_CLIENT_CREDIT_FLOOR,         \
        .pValue         = &pConfig->ulClientCreditStart         \
    },                                                          \
};
