/*
 * Copyright Likewise Software
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.  You should have received a copy of the GNU General
 * Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * LIKEWISE SOFTWARE MAKES THIS SOFTWARE AVAILABLE UNDER OTHER LICENSING
 * TERMS AS WELL.  IF YOU HAVE ENTERED INTO A SEPARATE LICENSE AGREEMENT
 * WITH LIKEWISE SOFTWARE, THEN YOU MAY ELECT TO USE THE SOFTWARE UNDER THE
 * TERMS OF THAT SOFTWARE LICENSE AGREEMENT INSTEAD OF THE TERMS OF THE GNU
 * GENERAL PUBLIC LICENSE, NOTWITHSTANDING THE ABOVE NOTICE.  IF YOU
 * HAVE QUESTIONS, OR WISH TO REQUEST A COPY OF THE ALTERNATE LICENSING
 * TERMS OFFERED BY LIKEWISE SOFTWARE, PLEASE CONTACT LIKEWISE SOFTWARE AT
 * license@likewisesoftware.com
 */

/*
 * Copyright (C) Likewise Software. All rights reserved.
 *
 * Module Name:
 *
 *        test_api.c
 *
 * Abstract:
 *
 *        Srv
 *
 *        Internal API unit tests
 *
 * Authors: Brian Koropoff (bkoropoff@likewise.com)
 */

#include "includes.h"

static const WCHAR homeShareName[] = SRV_SHARE_REPOSITORY_SPECIAL_SHARE_HOME_W;
static const WCHAR domainName[] = {'U','N','I','T',0};
static const WCHAR userName[] = {'t','e','s','t',0};

MU_TEST(shareapi, get_path_home_share)
{
    NTSTATUS status = STATUS_SUCCESS;
    static const WCHAR homeShareTemplate[] = {'C',':','\\','%','D','\\','%','U',0};
    static const WCHAR expected[] = {'C',':','\\','U','N','I','T','\\','t','e','s','t',0};
    SRV_SHARE_INFO info = {0};
    PWSTR pResult = NULL;

    info.pwszName = (PWSTR) homeShareName;
    info.pwszPath = (PWSTR) homeShareTemplate;

    status = SrvShareGetPath(&info, domainName, userName, &pResult);
    MU_ASSERT_EQUAL(MU_TYPE_INTEGER, status, STATUS_SUCCESS);
    MU_ASSERT(LwRtlWC16StringIsEqual(pResult, expected, TRUE));

    RTL_FREE(&pResult);
}
