/* Editor Settings: expandtabs and use 4 spaces for indentation
 * ex: set softtabstop=4 tabstop=8 expandtab shiftwidth=4: *
 */

/*
 * Copyright Likewise Software    2004-2008
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the license, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
 * General Public License for more details.  You should have received a copy
 * of the GNU Lesser General Public License along with this program.  If
 * not, see <http://www.gnu.org/licenses/>.
 *
 * LIKEWISE SOFTWARE MAKES THIS SOFTWARE AVAILABLE UNDER OTHER LICENSING
 * TERMS AS WELL.  IF YOU HAVE ENTERED INTO A SEPARATE LICENSE AGREEMENT
 * WITH LIKEWISE SOFTWARE, THEN YOU MAY ELECT TO USE THE SOFTWARE UNDER THE
 * TERMS OF THAT SOFTWARE LICENSE AGREEMENT INSTEAD OF THE TERMS OF THE GNU
 * LESSER GENERAL PUBLIC LICENSE, NOTWITHSTANDING THE ABOVE NOTICE.  IF YOU
 * HAVE QUESTIONS, OR WISH TO REQUEST A COPY OF THE ALTERNATE LICENSING
 * TERMS OFFERED BY LIKEWISE SOFTWARE, PLEASE CONTACT LIKEWISE SOFTWARE AT
 * license@likewisesoftware.com
 */

#ifndef _PARAMS_H_
#define _PARAMS_H_


typedef struct _PARAMETER
{
    PSTR  key;
    PSTR  val;
} PARAMETER, *PPARAMETER;


typedef enum _PARAM_TYPE {
    PT_CSTRING = 1,
    PT_WC16STRING,
    PT_WC16STRING_LIST,
    PT_CHAR,
    PT_INT32,
    PT_UINT32,
    PT_BOOLEAN,
    PT_SID,
    PT_SID_LIST
} PARAM_TYPE, *PPARAM_TYPE;


PSTR*
RpctGetStringList(
    PSTR       list,
    const CHAR sep
    );

VOID
RpctFreeStringList(
    PSTR *ppArray
    );

PPARAMETER
RpctGetOptionalParams(
    PSTR    pszOpt,
    PDWORD  pdwCount
    );

PCSTR
RpctFindValue(
    PPARAMETER pParams,
    DWORD      dwCount,
    PCSTR      pszKey
    );

DWORD
RpctFetchParameterValue(
    PPARAMETER pParams,
    DWORD Count,
    PCSTR Key,
    PARAM_TYPE Type,
    PVOID pValue,
    PCVOID pDefaultValue
    );

VOID
ParamInfo(
    PCSTR Name,
    PARAM_TYPE Type,
    PVOID pValue
    );


#endif /* _PARAMS_H_ */


/*
local variables:
mode: c
c-basic-offset: 4
indent-tabs-mode: nil
tab-width: 4
end:
*/
